import Toybox.Application;
import Toybox.Lang;
import Toybox.WatchUi;

using C as C;

class FacadeApp extends Application.AppBase {

    function initialize() {
        AppBase.initialize();
    }

    // onStart() is called on application start up
    function onStart(state as Dictionary?) as Void {
    }

    // onStop() is called when your application is exiting
    function onStop(state as Dictionary?) as Void {
    }

    // Return the initial view of your application here
    function getInitialView() as Array<Views or InputDelegates>? {
        return [ new FacadeView() ] as Array<Views or InputDelegates>;
    }

    //! Return the settings view and delegate
    //! @return Array Pair [View, Delegate]
    public function getSettingsView() as Array<Views or InputDelegates>? {
        return [new $.Menu(), new $.MenuDelegate()] as Array<Views or InputDelegates>;
    }

    // New app settings have been received so trigger a UI update
    function onSettingsChanged() as Void {
        C.logger("onSettingsChanged()");
        C.settings();
        WatchUi.requestUpdate();
    }

}

function getApp() as FacadeApp {
    return Application.getApp() as FacadeApp;
}
